// Création du contexte graphique
const cvs = document.getElementById("zone_de_dessin");
cvs.width = 800;
cvs.height = 850;
const ctx = cvs.getContext("2d");
const largImg = 120;
const hautImg = 160;
const xO = 10;
const yO = 10;
let tabImageCliquee1 =[];
let tabImageCliquee2 =[];
let compteurImage = 0;
let compteurImagesTrouvees = 0;
let finDuJeu = false;

// Création des sons
const sonClic = new Audio();
sonClic.src = "sons/clic.mp3";
const sonKlaxon = new Audio();
sonKlaxon.src = "sons/klaxon.mp3";
const sonHymne = new Audio();
sonHymne.src = "sons/hymne_uk.mp3";

// Création des images
for(let i=0; i<=8; i++){
    window["img" + i] = new Image();
    window["img" + i].src = "images/img" + i + ".jpg";
}

// Stockage des images dans un tableau
const tabImages = [];
for(let i=0; i<=7; i++){
    tabImages[2*i] = window["img" + (i+1)];
    tabImages[2*i+1] = window["img" + (i+1)];
}

// Mélange aléatoire des images du tabImages
tabImages.sort(() => Math.random() - 0.5);

// Création du tableau des images trouvées
const tabImagesTrouvees = [];
for(let i=0; i<=15; i++){
    tabImagesTrouvees[i]=img0;
}

// Dessin des images vignettes
function dessineImages(ctx, tabImg){
    for(let i=0; i<=3; i++){
        ctx.drawImage(tabImg[i],xO +i*largImg, yO);
        ctx.drawImage(tabImg[4 + i],xO +i*largImg, yO + hautImg);
        ctx.drawImage(tabImg[8 + i],xO +i*largImg, yO + 2*hautImg);
        ctx.drawImage(tabImg[12 + i],xO +i*largImg, yO + 3*hautImg);
    }
}

// Dessin de la grille
function dessineGrille(ctx){
    ctx.strokeStyle = "gold";
    ctx.lineWidth = 1;
    ctx.beginPath();
    for(let i=0; i<=4; i++){
        // Lignes verticales
        ctx.moveTo(xO + i*largImg, yO);
        ctx.lineTo(xO +i*largImg, yO + 4*hautImg);
        // Lignes horizontales
        ctx.moveTo(xO, yO + i*hautImg);
        ctx.lineTo(xO + 4*largImg, yO + i*hautImg);
    }
    ctx.stroke();
}

// Action souris sur la zone de dessin
cvs.addEventListener("click", infoImageCliquee);
function infoImageCliquee(e){
    if(e.clientX > xO && e.clientX < xO + 4*largImg && e.clientY > yO && e.clientY < yO + 4*hautImg){
        sonClic.play();
        if(finDuJeu === false){
            const decalageSouris = 8;
            let x = Math.floor((e.clientX - decalageSouris)/largImg);
            let y = Math.floor((e.clientY - decalageSouris)/ hautImg);
            let imageCliquee;
            
            if(y === 0){
                switch(x){
                    case 0: imageCliquee = tabImages[0];
                            break;
                    case 1: imageCliquee = tabImages[1];
                            break;
                    case 2: imageCliquee = tabImages[2];
                            break;
                    case 3: imageCliquee = tabImages[3];
                            break;      
                }
            }else if(y === 1){
                switch(x){
                    case 0: imageCliquee = tabImages[4];
                            break;
                    case 1: imageCliquee = tabImages[5];
                            break;
                    case 2: imageCliquee = tabImages[6];
                            break;
                    case 3: imageCliquee = tabImages[7];
                            break;      
                }
            }else if(y === 2){
                switch(x){
                    case 0: imageCliquee = tabImages[8];
                            break;
                    case 1: imageCliquee = tabImages[9];
                            break;
                    case 2: imageCliquee = tabImages[10];
                            break;
                    case 3: imageCliquee = tabImages[11];
                            break;      
                }
            }else if(y === 3){
                switch(x){
                    case 0: imageCliquee = tabImages[12];
                            break;
                    case 1: imageCliquee = tabImages[13];
                            break;
                    case 2: imageCliquee = tabImages[14];
                            break;
                    case 3: imageCliquee = tabImages[15];
                            break;      
                }
            }
        
            if(compteurImage === 0){
                tabImageCliquee1 = [imageCliquee, x*largImg + xO, y*hautImg + yO];
                tabImageCliquee2 = [];
                compteurImage = 1;
            }else if(x*largImg + xO !== tabImageCliquee1[1] || y*hautImg + yO !== tabImageCliquee1[2]){
                tabImageCliquee2 = [imageCliquee, x*largImg + xO, y*hautImg + yO];
                compteurImage = 0;
                miseAJourtabImagesTrouvees();
                if(compteurImagesTrouvees < 16){
                    setTimeout(miseAJourImages, 400);
                }else{
                    miseAJourImages();
                }
            }
            dessine();
        }else{
            setTimeout(rechargeLeJeu, 500);
        }
    }
}

function rechargeLeJeu(){
    finDuJeu = false;
    location.reload();
}

function miseAJourImages(){
    dessineImages(ctx, tabImagesTrouvees);
    dessineGrille(ctx);
}

function dessinImageCliquee(ctx){
    if(tabImageCliquee1.length > 0){
        ctx.drawImage(tabImageCliquee1[0], tabImageCliquee1[1], tabImageCliquee1[2]);
    }
    if(tabImageCliquee2.length > 0){
        ctx.drawImage(tabImageCliquee2[0], tabImageCliquee2[1], tabImageCliquee2[2]);
    }
}

function miseAJourtabImagesTrouvees(){
    if(tabImageCliquee1.length > 0 && tabImageCliquee2.length > 0){
        if(tabImageCliquee1[0] === tabImageCliquee2[0]){
            sonKlaxon.play();
            for(let i=0; i<tabImages.length; i++){
                if(tabImages[i] === tabImageCliquee1[0]){
                    tabImagesTrouvees[i] = tabImageCliquee1[0];
                    tabImageCliquee1 = [];
                    compteurImagesTrouvees++;
                }else if(tabImages[i] === tabImageCliquee2[0]){
                    tabImagesTrouvees[i] = tabImageCliquee2[0];
                    tabImageCliquee2 = [];
                    compteurImagesTrouvees++;
                }
            }
        }
    }
}

function debutDuJeu(){
    ctx.fillStyle = "black";
    ctx.font = "25px Arial, serif";
    ctx.fillText("Cliquer sur une case pour commencer", 30, 680);
}

function dessine(){
    if(compteurImagesTrouvees < 16){
        ctx.clearRect(0,0, cvs.width,cvs.height);
        dessineImages(ctx, tabImagesTrouvees);
        dessinImageCliquee(ctx);
        dessineGrille(ctx);
    }else{
        finDuJeu = true;
        sonHymne.play();
        ctx.fillStyle = "black";
        ctx.font = "50px Arial, serif";
        ctx.fillText("Vous avez gagné !!", 40, 695);
        ctx.font = "25px Arial, serif";
        ctx.fillText("Cliquer sur la grille pour recommencer", 40, 730);
    }
}

window.onload = () => {
    dessine();
    debutDuJeu();
}

